;================================================================================
; Pro-P1, Atari XL + mads [NRV 2010]
;================================================================================

; 4/2/2010 2:26:04 PM

;================================================================================

SetPlayerInfo

; update right coordinate
	lda m_playerLevelLeftX_H1
	clc
	adc m_playerSizeXMinusOne
	sta m_playerLevelRightX_H1
	lda m_playerLevelLeftX_H2
	adc #0
	sta m_playerLevelRightX_H2

; update top coordinate
	lda m_playerLevelBottomY_H1
	sec
	sbc m_playerSizeYMinusOne
	sta m_playerLevelTopY_H1
	lda m_playerLevelBottomY_H2
	sbc #0
	sta m_playerLevelTopY_H2

	rts


;================================================================================

SetPlayerScreenPos

; save old screen pos
	lda m_playerScreenLeftX
	sta m_oldPlayerScreenLeftX
	lda m_playerScreenTopY
	sta m_oldPlayerScreenTopY

; get new screen pos
; (this should use the "_H2" positions if the delta between the player
; and the camera is too big, 64 chars in X, or 32 chars in Y)

	lda m_playerLevelLeftX_H1
	sec
	sbc m_levelWindowX_H1
	clc
	adc #PM_BASE_SCREEN_X
	sta m_playerScreenLeftX

	lda m_playerLevelTopY_H1
	sec
	sbc m_levelWindowY_H1
	clc
	adc #PM_BASE_SCREEN_Y
	sta m_playerScreenTopY

; signal for the DLI to redraw the player
	inc m_redrawPlayerCounter

	rts


;================================================================================

DrawPlayer
	lda m_playerBaseColor
	sta COLPM0

	lda m_redrawPlayerCounter
	beq DP_exit

	lda m_playerScreenLeftX
	sta HPOSP0

	;ldx m_playerSizeY

	lda #0
	sta m_redrawPlayerCounter

	ldy m_oldPlayerScreenTopY
	sta p0_area_1,y
	sta p0_area_1+1,y
	sta p0_area_1+2,y
	sta p0_area_1+3,y
	sta p0_area_1+4,y
	sta p0_area_1+5,y
	sta p0_area_1+6,y
	sta p0_area_1+7,y

	ldy m_playerScreenTopY
	lda TabPlayerShape_01
	sta p0_area_1,y
	lda TabPlayerShape_01+1
	sta p0_area_1+1,y
	lda TabPlayerShape_01+2
	sta p0_area_1+2,y
	lda TabPlayerShape_01+3
	sta p0_area_1+3,y
	lda TabPlayerShape_01+4
	sta p0_area_1+4,y
	lda TabPlayerShape_01+5
	sta p0_area_1+5,y
	lda TabPlayerShape_01+6
	sta p0_area_1+6,y
	lda TabPlayerShape_01+7
	sta p0_area_1+7,y

DP_exit
	rts


;================================================================================

DrawPlayerExplosion
	lda m_playerBaseColor
	sta COLPM0

; 	lda m_redrawPlayerCounter
; 	beq DPE_exit
;
; 	lda #0
; 	sta m_redrawPlayerCounter


; erase previous player explosion frame
DPE_erase
	ldx #0
	ldy m_playerExplosionScreenTopY_H1

DPE_erase_loop
	lda #0
	sta p0_area_1,y

	tya
	clc
	adc m_playerExplosionStep
	bcs DPE_update_frame
	tay

	inx
	cpx m_playerSizeY
	bne DPE_erase_loop


; update step and explosion starting line
; if step +1 --> line - 3.5
; if step +2 --> line - 7.0

DPE_update_frame
	lda m_playerExplosionScreenTopY_L1
	sec
	sbc #128
	sta m_playerExplosionScreenTopY_L1

	lda m_playerExplosionScreenTopY_H1
	sbc #3
	bcs DPE_do_update


; reached top of the screen, end explosion, respawn player
	jsr InitPlayerInfo

	jmp DPE_exit


DPE_do_update
	sta m_playerExplosionScreenTopY_H1

	inc m_playerExplosionStep	; step +1
;	inc m_playerExplosionStep	; step +2


; draw new player explosion frame
DPE_draw
	ldx #0
	ldy m_playerExplosionScreenTopY_H1

DPE_draw_loop
	lda TabPlayerShape_01,x
	sta p0_area_1,y

	tya
	clc
	adc m_playerExplosionStep
	bcs DPE_exit
	tay

	inx
	cpx m_playerSizeY
	bne DPE_draw_loop


DPE_exit
	rts


m_playerExplosionScreenTopY_H1	.byte 0
m_playerExplosionScreenTopY_L1	.byte 0
m_playerExplosionStep			.byte 0


;================================================================================

CheckPlayerInLevelRightLimit

; update right coordinate
	lda m_playerLevelLeftX_H1
	clc
	adc m_playerSizeXMinusOne
	sta m_playerLevelRightX_H1
	lda m_playerLevelLeftX_H2
	adc #0
	sta m_playerLevelRightX_H2

	cmp m_levelSizeX_H2
	bcc CPILRL_exit
	bne CPILRL_reset_pos

	lda m_playerLevelRightX_H1
	cmp m_levelSizeX_H1
	bcc CPILRL_exit

CPILRL_reset_pos
	lda #0
	sta m_playerLevelLeftX_L1

	lda m_levelSizeX_H1
	sec
	sbc m_playerSizeX
	sta m_playerLevelLeftX_H1
	lda m_levelSizeX_H2
	sbc #0
	sta m_playerLevelLeftX_H2

	lda #1
	sta m_playerSideCollisionFlag

CPILRL_exit
	rts


;================================================================================

CheckPlayerInLevelBottomLimit

	lda m_playerLevelBottomY_H2
	cmp m_levelSizeY_H2
	bcc CPILBL_exit
	bne CPILBL_reset_pos

	lda m_playerLevelBottomY_H1
	cmp m_levelSizeY_H1
	bcc CPILBL_exit

CPILBL_reset_pos
	lda #0
	sta m_playerLevelBottomY_L1

	lda m_levelSizeY_H1
	sec
	sbc #1
	sta m_playerLevelBottomY_H1
	lda m_levelSizeY_H2
	sbc #0
	sta m_playerLevelBottomY_H2

	lda #1
	sta m_playerOverPlatformFlag

CPILBL_exit
	rts


;================================================================================

CheckHoleBelowPlayer

; get bottom char line
	lda m_playerLevelBottomY_H2
	sta m_charBuffer_H2
	lda m_playerLevelBottomY_H1
	clc
	adc #1	; check one pixel below the bottom line of the player
	bcc CHBP_get_char_line
	inc m_charBuffer_H2

CHBP_get_char_line
	lsr m_charBuffer_H2		; /2
	ror
	lsr m_charBuffer_H2		; /4
	ror
	lsr m_charBuffer_H2		; /8 = CHAR_PIXELS_Y
	ror

; check bottom level limit
	cmp m_levelCharSizeY
	bcs CHBP_no_hole

	tax
	lda TabLevelLineAddressLSB,x
	sta m_ptrLevelLine
	lda TabLevelLineAddressMSB,x
	sta m_ptrLevelLine+1

; update right coordinate
	lda m_playerLevelLeftX_H1
	clc
	adc m_playerSizeXMinusOne
	sta m_playerLevelRightX_H1
	lda m_playerLevelLeftX_H2
	adc #0
	sta m_playerLevelRightX_H2

; get left point char column
	lda m_playerLevelLeftX_H2
	sta m_charBuffer_H2
	lda m_playerLevelLeftX_H1
	lsr m_charBuffer_H2		; /2
	ror
	lsr m_charBuffer_H2		; /4 = CHAR_PIXELS_X
	ror

	tay
	lda (m_ptrLevelLine),y
	tax
	lda TabCharDefinition,x
	sta m_leftBottomChar

; get right point char column
	lda m_playerLevelRightX_H2
	sta m_charBuffer_H2
	lda m_playerLevelRightX_H1
	lsr m_charBuffer_H2		; /2
	ror
	lsr m_charBuffer_H2		; /4 = CHAR_PIXELS_X
	ror

	tay
	lda (m_ptrLevelLine),y
	tax
	lda TabCharDefinition,x
	sta m_rightBottomChar

; fast collision check
	lda m_leftBottomChar
	and #15
	cmp #CT_BLOCK
	bne CHBP_check_next_char

	lda m_leftBottomChar
	and #%00010000
	bne CHBP_no_hole

CHBP_check_next_char
	lda m_rightBottomChar
	and #15
	cmp #CT_BLOCK
	bne CHBP_hole

	lda m_rightBottomChar
	and #%00010000
	bne CHBP_no_hole

CHBP_hole
; need to change the player to the falling state
	lda #0
	sta m_playerOverPlatformFlag

	rts

CHBP_no_hole
	lda #1
	sta m_playerOverPlatformFlag

	rts


;================================================================================

CheckPlayerBottomCollision

; get bottom char line
	lda m_playerLevelBottomY_H2
	sta m_charBuffer_H2
	lda m_playerLevelBottomY_H1

	lsr m_charBuffer_H2		; /2
	ror
	lsr m_charBuffer_H2		; /4
	ror
	lsr m_charBuffer_H2		; /8 = CHAR_PIXELS_Y
	ror

	tax
	lda TabLevelLineAddressLSB,x
	sta m_ptrLevelLine
	lda TabLevelLineAddressMSB,x
	sta m_ptrLevelLine+1

; update right coordinate
	lda m_playerLevelLeftX_H1
	clc
	adc m_playerSizeXMinusOne
	sta m_playerLevelRightX_H1
	lda m_playerLevelLeftX_H2
	adc #0
	sta m_playerLevelRightX_H2

; get left point char column
	lda m_playerLevelLeftX_H2
	sta m_charBuffer_H2
	lda m_playerLevelLeftX_H1
	lsr m_charBuffer_H2		; /2
	ror
	lsr m_charBuffer_H2		; /4 = CHAR_PIXELS_X
	ror

	tay
	lda (m_ptrLevelLine),y
	tax
	lda TabCharDefinition,x
	sta m_leftBottomChar

; get right point char column
	lda m_playerLevelRightX_H2
	sta m_charBuffer_H2
	lda m_playerLevelRightX_H1
	lsr m_charBuffer_H2		; /2
	ror
	lsr m_charBuffer_H2		; /4 = CHAR_PIXELS_X
	ror

	tay
	lda (m_ptrLevelLine),y
	tax
	lda TabCharDefinition,x
	sta m_rightBottomChar

; fast collision check
	lda m_leftBottomChar
	and #15
	cmp #CT_BLOCK
	bne CPBC_check_next_char

	lda m_leftBottomChar
	and #%00010000
	bne CPBC_found_collision

CPBC_check_next_char
	lda m_rightBottomChar
	and #15
	cmp #CT_BLOCK
	bne CPBC_exit

	lda m_rightBottomChar
	and #%00010000
	beq CPBC_exit

CPBC_found_collision
; need to move the player up and change to the platform state
	lda #1
	sta m_playerOverPlatformFlag

	lda #0
	sta m_playerLevelBottomY_L1

	lda m_playerLevelBottomY_H1
	and #%11111000		; mask for CHAR_PIXELS_Y
	sec
	sbc #1
	sta m_playerLevelBottomY_H1
	lda m_playerLevelBottomY_H2
	sbc #0
	sta m_playerLevelBottomY_H2

CPBC_exit
	rts


m_charBuffer_H2
	.byte 0

m_leftBottomChar
	.byte 0
m_middleBottomChar
	.byte 0
m_rightBottomChar
	.byte 0

m_middleBottomCharPosX
	.byte 0

m_bottomPosOffsetX
	.byte 0
m_bottomPosOffsetY
	.byte 0

m_leftTopChar
	.byte 0
m_rightTopChar
	.byte 0

m_waterPlayerDirectionFlag
	.byte 0
m_playerOnWaterSurfaceFlag
	.byte 0


;================================================================================

CheckPlayerTopCollision

; update top coordinate
	lda m_playerLevelBottomY_H1
	sec
	sbc m_playerSizeYMinusOne
	sta m_playerLevelTopY_H1
	lda m_playerLevelBottomY_H2
	sbc #0
	sta m_playerLevelTopY_H2

; get top char line
	lda m_playerLevelTopY_H2
	sta m_charBuffer_H2
	lda m_playerLevelTopY_H1

	lsr m_charBuffer_H2		; /2
	ror
	lsr m_charBuffer_H2		; /4
	ror
	lsr m_charBuffer_H2		; /8 = CHAR_PIXELS_Y
	ror

	tax
	lda TabLevelLineAddressLSB,x
	sta m_ptrLevelLine
	lda TabLevelLineAddressMSB,x
	sta m_ptrLevelLine+1

; update right coordinate
	lda m_playerLevelLeftX_H1
	clc
	adc m_playerSizeXMinusOne
	sta m_playerLevelRightX_H1
	lda m_playerLevelLeftX_H2
	adc #0
	sta m_playerLevelRightX_H2

; get left point char column
	lda m_playerLevelLeftX_H2
	sta m_charBuffer_H2
	lda m_playerLevelLeftX_H1
	lsr m_charBuffer_H2		; /2
	ror
	lsr m_charBuffer_H2		; /4 = CHAR_PIXELS_X
	ror

	tay
	lda (m_ptrLevelLine),y
	tax
	lda TabCharDefinition,x
	sta m_leftTopChar

; get right point char column
	lda m_playerLevelRightX_H2
	sta m_charBuffer_H2
	lda m_playerLevelRightX_H1
	lsr m_charBuffer_H2		; /2
	ror
	lsr m_charBuffer_H2		; /4 = CHAR_PIXELS_X
	ror

	tay
	lda (m_ptrLevelLine),y
	tax
	lda TabCharDefinition,x
	sta m_rightTopChar

; fast collision check
	lda m_leftTopChar
	and #15
	cmp #CT_BLOCK
	bne CPTC_check_next_char

	lda m_leftTopChar
	and #%00100000
	bne CPTC_found_collision

CPTC_check_next_char
	lda m_rightTopChar
	and #15
	cmp #CT_BLOCK
	bne CPTC_exit

	lda m_rightTopChar
	and #%00100000
	beq CPTC_exit

CPTC_found_collision
; need to move the player down
	lda #1
	sta m_playerTopCollisionFlag

	lda #0
	sta m_playerLevelBottomY_L1

	lda m_playerLevelTopY_H1
	and #%11111000		; mask for CHAR_PIXELS_Y
	clc
	adc #CHAR_PIXELS_Y ; +m_playerSizeY
	sta m_playerLevelBottomY_H1
	lda m_playerLevelTopY_H2
	adc #0
	sta m_playerLevelBottomY_H2

	lda m_playerLevelBottomY_H1
	clc
	adc m_playerSizeYMinusOne
	sta m_playerLevelBottomY_H1
	lda m_playerLevelBottomY_H2
	adc #0
	sta m_playerLevelBottomY_H2

CPTC_exit
	rts


;================================================================================

CheckPlayerLeftCollision

; update top coordinate
	lda m_playerLevelBottomY_H1
	sec
	sbc m_playerSizeYMinusOne
	sta m_playerLevelTopY_H1
	lda m_playerLevelBottomY_H2
	sbc #0
	sta m_playerLevelTopY_H2

; get left point char column
	lda m_playerLevelLeftX_H2
	sta m_charBuffer_H2
	lda m_playerLevelLeftX_H1

	lsr m_charBuffer_H2		; /2
	ror
	lsr m_charBuffer_H2		; /4 = CHAR_PIXELS_X
	ror

	tay

; get top char line
	lda m_playerLevelTopY_H2
	sta m_charBuffer_H2
	lda m_playerLevelTopY_H1

	lsr m_charBuffer_H2		; /2
	ror
	lsr m_charBuffer_H2		; /4
	ror
	lsr m_charBuffer_H2		; /8 = CHAR_PIXELS_Y
	ror

	tax
	lda TabLevelLineAddressLSB,x
	sta m_ptrLevelLine
	lda TabLevelLineAddressMSB,x
	sta m_ptrLevelLine+1

	lda (m_ptrLevelLine),y
	tax
	lda TabCharDefinition,x
	sta m_leftTopChar

; get bottom char line
	lda m_playerLevelBottomY_H2
	sta m_charBuffer_H2
	lda m_playerLevelBottomY_H1

	lsr m_charBuffer_H2		; /2
	ror
	lsr m_charBuffer_H2		; /4
	ror
	lsr m_charBuffer_H2		; /8 = CHAR_PIXELS_Y
	ror

	tax
	lda TabLevelLineAddressLSB,x
	sta m_ptrLevelLine
	lda TabLevelLineAddressMSB,x
	sta m_ptrLevelLine+1

	lda (m_ptrLevelLine),y
	tax
	lda TabCharDefinition,x
	sta m_leftBottomChar

; fast collision check
	lda m_leftTopChar
	and #15
	cmp #CT_BLOCK
	bne CPLC_check_next_char

	lda m_leftTopChar
	and #%10000000
	bne CPLC_found_collision

CPLC_check_next_char
	lda m_leftBottomChar
	and #15
	cmp #CT_BLOCK
	bne CPLC_exit

	lda m_leftBottomChar
	and #%10000000
	beq CPLC_exit

CPLC_found_collision
	lda #1
	sta m_playerSideCollisionFlag

; need to move the player to the right
	lda #0
	sta m_playerLevelLeftX_L1

	lda m_playerLevelLeftX_H1
	and #%11111100		; mask for CHAR_PIXELS_X
	clc
	adc #CHAR_PIXELS_X
	sta m_playerLevelLeftX_H1
	lda m_playerLevelLeftX_H2
	adc #0
	sta m_playerLevelLeftX_H2

CPLC_exit
	rts


;================================================================================

CheckPlayerRightCollision

; update top coordinate
	lda m_playerLevelBottomY_H1
	sec
	sbc m_playerSizeYMinusOne
	sta m_playerLevelTopY_H1
	lda m_playerLevelBottomY_H2
	sbc #0
	sta m_playerLevelTopY_H2

; update right coordinate
	lda m_playerLevelLeftX_H1
	clc
	adc m_playerSizeXMinusOne
	sta m_playerLevelRightX_H1
	lda m_playerLevelLeftX_H2
	adc #0
	sta m_playerLevelRightX_H2

; get right point char column
	lda m_playerLevelRightX_H2
	sta m_charBuffer_H2
	lda m_playerLevelRightX_H1

	lsr m_charBuffer_H2		; /2
	ror
	lsr m_charBuffer_H2		; /4 = CHAR_PIXELS_X
	ror

	tay

; get top char line
	lda m_playerLevelTopY_H2
	sta m_charBuffer_H2
	lda m_playerLevelTopY_H1

	lsr m_charBuffer_H2		; /2
	ror
	lsr m_charBuffer_H2		; /4
	ror
	lsr m_charBuffer_H2		; /8 = CHAR_PIXELS_Y
	ror

	tax
	lda TabLevelLineAddressLSB,x
	sta m_ptrLevelLine
	lda TabLevelLineAddressMSB,x
	sta m_ptrLevelLine+1

	lda (m_ptrLevelLine),y
	tax
	lda TabCharDefinition,x
	sta m_rightTopChar

; get bottom char line
	lda m_playerLevelBottomY_H2
	sta m_charBuffer_H2
	lda m_playerLevelBottomY_H1

	lsr m_charBuffer_H2		; /2
	ror
	lsr m_charBuffer_H2		; /4
	ror
	lsr m_charBuffer_H2		; /8 = CHAR_PIXELS_Y
	ror

	tax
	lda TabLevelLineAddressLSB,x
	sta m_ptrLevelLine
	lda TabLevelLineAddressMSB,x
	sta m_ptrLevelLine+1

	lda (m_ptrLevelLine),y
	tax
	lda TabCharDefinition,x
	sta m_rightBottomChar

; fast collision check
	lda m_rightTopChar
	and #15
	cmp #CT_BLOCK
	bne CPRC_check_next_char

	lda m_rightTopChar
	and #%01000000
	bne CPRC_found_collision

CPRC_check_next_char
	lda m_rightBottomChar
	and #15
	cmp #CT_BLOCK
	bne CPRC_exit

	lda m_rightBottomChar
	and #%01000000
	beq CPRC_exit

CPRC_found_collision
	lda #1
	sta m_playerSideCollisionFlag

; need to move the player to the left
	lda #0
	sta m_playerLevelLeftX_L1

	lda m_playerLevelRightX_H1
	and #%11111100		; mask for CHAR_PIXELS_X
	sec
	sbc m_playerSizeX
	sta m_playerLevelLeftX_H1
	lda m_playerLevelRightX_H2
	sbc #0
	sta m_playerLevelLeftX_H2

CPRC_exit
	rts


;================================================================================

AddSideAccelToSpeed

; update frame speed with frame accel
	lda m_playerSideSpeed_L1
	clc
	adc m_playerSideAccel_L1
	sta m_playerSideSpeed_L1
	lda m_playerSideSpeed_H1
	adc m_playerSideAccel_H1

ASATS_entry_point
	sta m_playerSideSpeed_H1

; check max frame speed
	cmp m_playerMaxSideSpeed_H1
	bcc ASATS_exit			; lower than max speed
	bne ASATS_max_speed		; greater than max speed

; need to check the low byte
	lda m_playerMaxSideSpeed_L1
	cmp m_playerSideSpeed_L1
	bcs ASATS_exit			; lower or equal to max speed

ASATS_max_speed			; is higher than the max speed
	lda m_playerMaxSideSpeed_H1
	sta m_playerSideSpeed_H1
	lda m_playerMaxSideSpeed_L1
	sta m_playerSideSpeed_L1

ASATS_exit
	rts


;================================================================================

; SubstractSideAccelToSpeed
; 
; ; update frame speed with frame accel
; 	lda m_playerSideSpeed_L1
; 	sec
; 	sbc m_playerSideAccel_L1
; 	sta m_playerSideSpeed_L1
; 	lda m_playerSideSpeed_H1
; 	sbc m_playerSideAccel_H1
; 
; SSATS_entry_point
; 	bcs SSATS_dont_reset_speed
; 
; SSATS_reset_speed
; 	lda #PSD_NONE
; 	sta m_lastPlayerSideDirection
; 
; 	lda #0
; 	sta m_playerSideSpeed_L1
; 
; SSATS_dont_reset_speed
; 	sta m_playerSideSpeed_H1
; 
; 	rts


;================================================================================

; AddSideDeaccelToSpeed
;
; ; update frame speed with frame accel
; 	lda m_playerSideSpeed_L1
; 	clc
; 	adc m_playerSideDeaccel_L1
; 	sta m_playerSideSpeed_L1
; 	lda m_playerSideSpeed_H1
; 	adc m_playerSideDeaccel_H1
;
; 	jmp ASATS_entry_point


;================================================================================

SubstractSideDeaccelToSpeed

; update frame speed with frame accel
	lda m_playerSideSpeed_L1
	sec
	sbc m_playerSideDeaccel_L1
	sta m_playerSideSpeed_L1
	lda m_playerSideSpeed_H1
	sbc m_playerSideDeaccel_H1

	;jmp SSATS_entry_point

	bcs SSDTS_dont_reset_speed

SSDTS_reset_speed
	lda #PSD_NONE
	sta m_lastPlayerSideDirection

	lda #0
	sta m_playerSideSpeed_L1

SSDTS_dont_reset_speed
	sta m_playerSideSpeed_H1

	rts


;================================================================================

; AddSideAirAccelToSpeed
;
; ; update frame speed with frame accel
; 	lda m_playerSideSpeed_L1
; 	clc
; 	adc m_playerSideAirAccel_L1
; 	sta m_playerSideSpeed_L1
; 	lda m_playerSideSpeed_H1
; 	adc m_playerSideAirAccel_H1
; 
; 	jmp ASATS_entry_point


;================================================================================

; SubstractSideAirAccelToSpeed
; 
; ; update frame speed with frame accel
; 	lda m_playerSideSpeed_L1
; 	sec
; 	sbc m_playerSideAirAccel_L1
; 	sta m_playerSideSpeed_L1
; 	lda m_playerSideSpeed_H1
; 	sbc m_playerSideAirAccel_H1
; 
; 	jmp SSATS_entry_point


;================================================================================

AddSideSpeedToPosition

; update player side position
	lda m_playerLevelLeftX_L1
	clc
	adc m_playerSideSpeed_L1
	sta m_playerLevelLeftX_L1
	lda m_playerLevelLeftX_H1
	adc m_playerSideSpeed_H1
	sta m_playerLevelLeftX_H1
	lda m_playerLevelLeftX_H2
	adc #0
	sta m_playerLevelLeftX_H2

; check collisions for a player moving to the right
	lda #0
	sta m_playerSideCollisionFlag

; check level right side limit
	jsr CheckPlayerInLevelRightLimit

	lda m_playerSideCollisionFlag
	bne ASSTP_found_collision

	jsr CheckPlayerRightCollision

	lda m_playerSideCollisionFlag
	beq ASSTP_exit

ASSTP_found_collision
	lda #0
	sta m_playerSideSpeed_H1
	sta m_playerSideSpeed_L1

	;SetPMColor 0, 2, 6

ASSTP_exit
	rts


;================================================================================

SubstractSideSpeedToPosition

; update player side position
	lda m_playerLevelLeftX_L1
	sec
	sbc m_playerSideSpeed_L1
	sta m_playerLevelLeftX_L1
	lda m_playerLevelLeftX_H1
	sbc m_playerSideSpeed_H1
	sta m_playerLevelLeftX_H1
	lda m_playerLevelLeftX_H2
	sbc #0
	sta m_playerLevelLeftX_H2

; check collisions for a player moving to the left

; check level left side limit
	bcs SSSTP_check_left_collision

	lda #0
	sta m_playerLevelLeftX_H2
	sta m_playerLevelLeftX_H1
	sta m_playerLevelLeftX_L1

	jmp SSSTP_found_collision

SSSTP_check_left_collision
	lda #0
	sta m_playerSideCollisionFlag

	jsr CheckPlayerLeftCollision

	lda m_playerSideCollisionFlag
	beq SSSTP_exit

SSSTP_found_collision
	lda #0
	sta m_playerSideSpeed_H1
	sta m_playerSideSpeed_L1

	;SetPMColor 0, 2, 6

SSSTP_exit
	rts


;================================================================================

AddGravityAccelToSpeed

; update frame speed with frame accel
	lda m_playerSpeedY_L1
	clc
	adc m_playerGravityAccel_L1
	sta m_playerSpeedY_L1
	lda m_playerSpeedY_H1
	adc m_playerGravityAccel_H1
	sta m_playerSpeedY_H1

; check max frame speed
	cmp m_playerMaxFallSpeed_H1
	bcc AGATS_exit			; lower than max speed
	bne AGATS_max_speed		; greater than max speed

; need to check the low byte
	lda m_playerMaxFallSpeed_L1
	cmp m_playerSpeedY_L1
	bcs AGATS_exit			; lower or equal to max speed

AGATS_max_speed			; is higher than the max speed
	lda m_playerMaxFallSpeed_H1
	sta m_playerSpeedY_H1
	lda m_playerMaxFallSpeed_L1
	sta m_playerSpeedY_L1

AGATS_exit
	rts


;================================================================================

SubstractGravityAccelToSpeed

; update frame speed with frame accel
	lda m_playerSpeedY_L1
	sec
	sbc m_playerGravityAccel_L1
	sta m_playerSpeedY_L1
	lda m_playerSpeedY_H1
	sbc m_playerGravityAccel_H1
	bcs SGATS_dont_reset_speed

SGATS_reset_speed
	lda #0
	sta m_playerSpeedY_L1

SGATS_dont_reset_speed
	sta m_playerSpeedY_H1

	rts


;================================================================================

AddSpeedYToPosition

; update player position in Y
	lda m_playerLevelBottomY_L1
	clc
	adc m_playerSpeedY_L1
	sta m_playerLevelBottomY_L1
	lda m_playerLevelBottomY_H1
	adc m_playerSpeedY_H1
	sta m_playerLevelBottomY_H1
	lda m_playerLevelBottomY_H2
	adc #0
	sta m_playerLevelBottomY_H2

; check collisions for a player moving down
	lda #0
	sta m_playerOverPlatformFlag

; check level bottom limit collision
	jsr CheckPlayerInLevelBottomLimit

	lda m_playerOverPlatformFlag
	bne ASYTP_exit

; check collision with the top of a platform
	jsr CheckPlayerBottomCollision

ASYTP_exit
	rts


;================================================================================

SubstractSpeedYToPosition

; update player position in Y
	lda m_playerLevelBottomY_L1
	sec
	sbc m_playerSpeedY_L1
	sta m_playerLevelBottomY_L1
	lda m_playerLevelBottomY_H1
	sbc m_playerSpeedY_H1
	sta m_playerLevelBottomY_H1
	lda m_playerLevelBottomY_H2
	sbc #0
	sta m_playerLevelBottomY_H2

; update top coordinate
	lda m_playerLevelBottomY_H1
	sec
	sbc m_playerSizeYMinusOne
	sta m_playerLevelTopY_H1
	lda m_playerLevelBottomY_H2
	sbc #0
	sta m_playerLevelTopY_H2

; check collisions for a player moving up

; check level top limit collision
	bcs SSYTP_check_platform_bottom

	lda #0
	sta m_playerLevelBottomY_L1
	sta m_playerLevelBottomY_H2

	lda m_playerSizeYMinusOne
	sta m_playerLevelBottomY_H1

	jmp SSYTP_found_collision

SSYTP_check_platform_bottom
; check collision with the bottom of a platform
	lda #0
	sta m_playerTopCollisionFlag

	jsr CheckPlayerTopCollision

	lda m_playerTopCollisionFlag
	beq SSYTP_exit

SSYTP_found_collision
	lda #0
	sta m_playerSpeedY_H1
	sta m_playerSpeedY_L1

SSYTP_exit
	rts


;================================================================================

AddWaterAccelToSpeed

; update frame speed with frame accel
	lda m_playerSpeedY_L1
	clc
	adc m_playerWaterAccelY_L1
	sta m_playerSpeedY_L1
	lda m_playerSpeedY_H1
	adc m_playerWaterAccelY_H1
	sta m_playerSpeedY_H1

; check max frame speed
	cmp m_playerMaxWaterSpeedY_H1
	bcc AWATS_exit			; lower than max speed
	bne AWATS_max_speed		; greater than max speed

; need to check the low byte
	lda m_playerMaxWaterSpeedY_L1
	cmp m_playerSpeedY_L1
	bcs AWATS_exit			; lower or equal to max speed

AWATS_max_speed			; is higher than the max speed
	lda m_playerMaxWaterSpeedY_H1
	sta m_playerSpeedY_H1
	lda m_playerMaxWaterSpeedY_L1
	sta m_playerSpeedY_L1

AWATS_exit
	rts


;================================================================================

SubstractWaterAccelToSpeed

; update frame speed with frame accel
	lda m_playerSpeedY_L1
	sec
	sbc m_playerWaterAccelY_L1
	sta m_playerSpeedY_L1
	lda m_playerSpeedY_H1
	sbc m_playerWaterAccelY_H1
	bcs SWATS_dont_reset_speed

SWATS_reset_speed
	lda #0
	sta m_playerSpeedY_L1

SWATS_dont_reset_speed
	sta m_playerSpeedY_H1

	rts


;================================================================================

AddWaterMoveUpAccelToSpeed

; update frame speed with frame accel
	lda m_playerSpeedY_L1
	clc
	adc m_playerWaterAccelY_L1
	sta m_playerSpeedY_L1
	lda m_playerSpeedY_H1
	adc m_playerWaterAccelY_H1
	sta m_playerSpeedY_H1

; check max frame speed
	cmp m_playerMoveWaterSpeedY_H1
	bcc AWMUATS_exit			; lower than max speed
	bne AWMUATS_max_speed		; greater than max speed

; need to check the low byte
	lda m_playerMoveWaterSpeedY_L1
	cmp m_playerSpeedY_L1
	bcs AWMUATS_exit			; lower or equal to max speed

AWMUATS_max_speed			; is higher than the max speed
	lda m_playerMoveWaterSpeedY_H1
	sta m_playerSpeedY_H1
	lda m_playerMoveWaterSpeedY_L1
	sta m_playerSpeedY_L1

AWMUATS_exit
	rts


;================================================================================

AddWaterMoveDownAccelToSpeed

; check max frame speed
	lda m_playerMaxWaterSpeedY_H1
	cmp m_playerSpeedY_H1
	bcc AWMAATS_exit			; greater than max speed, exit
	bne AWMAATS_add			; lower than the max, continue with the add

; need to check the low byte
	lda m_playerSpeedY_L1
	cmp m_playerMaxWaterSpeedY_L1
	bcs AWMAATS_exit			; greater or equal to max speed, exit

AWMAATS_add
; update frame speed with frame accel
	lda m_playerSpeedY_L1
	clc
	adc m_playerWaterAccelY_L1
	sta m_playerSpeedY_L1
	lda m_playerSpeedY_H1
	adc m_playerWaterAccelY_H1
	sta m_playerSpeedY_H1

; check max frame speed
	cmp m_playerMaxWaterSpeedY_H1
	bcc AWMAATS_exit			; lower than max speed
	bne AWMAATS_max_speed		; greater than max speed

; need to check the low byte
	lda m_playerMaxWaterSpeedY_L1
	cmp m_playerSpeedY_L1
	bcs AWMAATS_exit			; lower or equal to max speed

AWMAATS_max_speed			; is higher than the max speed
	lda m_playerMaxWaterSpeedY_H1
	sta m_playerSpeedY_H1
	lda m_playerMaxWaterSpeedY_L1
	sta m_playerSpeedY_L1

AWMAATS_exit
	rts


;================================================================================

CheckPlayerBottomDownPos

; get bottom char line
	lda m_playerLevelBottomY_H2
	sta m_charBuffer_H2

	lda m_playerLevelBottomY_H1
	clc
	adc m_bottomPosOffsetY
	bcc CPBDP_offset_no_carry
	inc m_charBuffer_H2

CPBDP_offset_no_carry
	lsr m_charBuffer_H2		; /2
	ror
	lsr m_charBuffer_H2		; /4
	ror
	lsr m_charBuffer_H2		; /8 = CHAR_PIXELS_Y
	ror

	tax
	lda TabLevelLineAddressLSB,x
	sta m_ptrLevelLine
	lda TabLevelLineAddressMSB,x
	sta m_ptrLevelLine+1

; get left to right point char column
	lda m_playerLevelLeftX_H2
	sta m_charBuffer_H2

	lda m_playerLevelLeftX_H1
	clc
	adc m_bottomPosOffsetX
	bcc CPBDP_no_carry
	inc m_charBuffer_H2
CPBDP_no_carry

	lsr m_charBuffer_H2		; /2
	ror
	lsr m_charBuffer_H2		; /4 = CHAR_PIXELS_X
	ror

	tay
	sty m_middleBottomCharPosX
	lda (m_ptrLevelLine),y
	tax
	lda TabCharDefinition,x
	sta m_middleBottomChar

	rts


;================================================================================

CheckPlayerBottomUpPos

; get bottom char line
	lda m_playerLevelBottomY_H2
	sta m_charBuffer_H2

	lda m_playerLevelBottomY_H1
	sec
	sbc m_bottomPosOffsetY
	bcs CPBDP_offset_no_carry
	dec m_charBuffer_H2

	jmp CPBDP_offset_no_carry


