;================================================================================
; Pro-P1, Atari XL + mads [NRV 2010]
;================================================================================

; 4/2/2010 2:26:32 PM

;================================================================================

SetPlayerMethod
	stx m_playerState

	lda TabPlayerMethodLSB,x
	sta m_playerMethodPointer
	lda TabPlayerMethodMSB,x
	sta m_playerMethodPointer+1

	lda TabPlayerMethodColor,x
	sta m_playerBaseColor

	lda TabPlayerMethodInitLSB,x
	sta m_pageZeroTempPointer
	lda TabPlayerMethodInitMSB,x
	sta m_pageZeroTempPointer+1

	jmp (m_pageZeroTempPointer)

	;rts


TabPlayerMethodColor
.ifndef PAL_VERSION
	.byte 10, 11*16+10, 9*16+10, 9*16+10, 1*16+12, 7*16+8, 4, 2*16+6
.else
	.byte 10, 10*16+10, 8*16+10, 8*16+10, 15*16+12, 7*16+8, 4, 1*16+6
.endif


TabPlayerMethodLSB
	.byte <PlayerMethodStatic, <PlayerMethodOverPlatform
	.byte <PlayerMethodJumping, <PlayerMethodFalling
	.byte <PlayerMethodClimbing, <PlayerMethodInWater
	.byte <PlayerMethodGravityTest, <PlayerMethodLose

TabPlayerMethodMSB
	.byte >PlayerMethodStatic, >PlayerMethodOverPlatform
	.byte >PlayerMethodJumping, >PlayerMethodFalling
	.byte >PlayerMethodClimbing, >PlayerMethodInWater
	.byte >PlayerMethodGravityTest, >PlayerMethodLose


TabPlayerMethodInitLSB
	.byte <PlayerMethodInitStatic, <PlayerMethodInitOverPlatform
	.byte <PlayerMethodInitJumping, <PlayerMethodInitFalling
	.byte <PlayerMethodInitClimbing, <PlayerMethodInitInWater
	.byte <PlayerMethodInitGravityTest, <PlayerMethodInitLose

TabPlayerMethodInitMSB
	.byte >PlayerMethodInitStatic, >PlayerMethodInitOverPlatform
	.byte >PlayerMethodInitJumping, >PlayerMethodInitFalling
	.byte >PlayerMethodInitClimbing, >PlayerMethodInitInWater
	.byte >PlayerMethodInitGravityTest, >PlayerMethodInitLose


;================================================================================
;================================================================================
PlayerMethodInitStatic


	rts


;================================================================================
PlayerMethodInitOverPlatform

; clear player speed in Y
	lda #0
	sta m_playerSpeedY_H1
	sta m_playerSpeedY_L1

; init max side speed
	lda #SIDE_SPEED_LAND_H1
	sta m_playerMaxSideSpeed_H1
	lda #SIDE_SPEED_LAND_L1
	sta m_playerMaxSideSpeed_L1

; init side accelerations
	lda #SIDE_ACCEL_LAND_H1
	sta m_playerSideAccel_H1
	lda #SIDE_ACCEL_LAND_L1
	sta m_playerSideAccel_L1

	lda #SIDE_DEACCEL_LAND_H1
	sta m_playerSideDeaccel_H1
	lda #SIDE_DEACCEL_LAND_L1
	sta m_playerSideDeaccel_L1

	rts


;================================================================================
PlayerMethodInitJumping

; hold jump for this number of frames, if the button is still pressed
	lda #JUMP_HOLD_FRAMES
	sta m_playerHoldJumpCounter

	lda m_playerJumpSpeed_H1
	sta m_playerSpeedY_H1
	lda m_playerJumpSpeed_L1
	sta m_playerSpeedY_L1

; init max side speed
	lda #SIDE_SPEED_AIR_H1
	sta m_playerMaxSideSpeed_H1
	lda #SIDE_SPEED_AIR_L1
	sta m_playerMaxSideSpeed_L1

; init side accelerations
	lda #SIDE_ACCEL_AIR_H1
	sta m_playerSideAccel_H1
	lda #SIDE_ACCEL_AIR_L1
	sta m_playerSideAccel_L1

	lda #SIDE_DEACCEL_AIR_H1
	sta m_playerSideDeaccel_H1
	lda #SIDE_DEACCEL_AIR_L1
	sta m_playerSideDeaccel_L1

	rts


;================================================================================
PlayerMethodInitFalling

; init max side speed
	lda #SIDE_SPEED_AIR_H1
	sta m_playerMaxSideSpeed_H1
	lda #SIDE_SPEED_AIR_L1
	sta m_playerMaxSideSpeed_L1

; init side accelerations
	lda #SIDE_ACCEL_AIR_H1
	sta m_playerSideAccel_H1
	lda #SIDE_ACCEL_AIR_L1
	sta m_playerSideAccel_L1

	lda #SIDE_DEACCEL_AIR_H1
	sta m_playerSideDeaccel_H1
	lda #SIDE_DEACCEL_AIR_L1
	sta m_playerSideDeaccel_L1

	rts


;================================================================================
PlayerMethodInitClimbing

; clear player speed in X and Y
	lda #0
	sta m_playerSideSpeed_H1
	sta m_playerSideSpeed_L1
	sta m_playerSpeedY_H1
	sta m_playerSpeedY_L1

	rts


;================================================================================
PlayerMethodInitInWater

; set starting direction going down (0 = going up, 1 = going down)
	lda #1
	sta m_waterPlayerDirectionFlag

	lda #0
	sta m_playerOnWaterSurfaceFlag

; reduce in half current falling speed
	lsr m_playerSpeedY_H1
	ror m_playerSpeedY_L1

; reduce in half current side speed
	lsr m_playerSideSpeed_H1
	ror m_playerSideSpeed_L1

; init max side speed
	lda #SIDE_SPEED_WATER_H1
	sta m_playerMaxSideSpeed_H1
	lda #SIDE_SPEED_WATER_L1
	sta m_playerMaxSideSpeed_L1

; init side accelerations
	lda #SIDE_ACCEL_WATER_H1
	sta m_playerSideAccel_H1
	lda #SIDE_ACCEL_WATER_L1
	sta m_playerSideAccel_L1

	lda #SIDE_DEACCEL_WATER_H1
	sta m_playerSideDeaccel_H1
	lda #SIDE_DEACCEL_WATER_L1
	sta m_playerSideDeaccel_L1

; disable jump for some frames
	lda #WATER_NO_JUMP_FRAMES
	sta m_playerNoJumpTimer
	
	rts


;================================================================================
PlayerMethodInitGravityTest


	rts


;================================================================================
PlayerMethodInitLose
	lda m_playerScreenTopY
	sta m_playerExplosionScreenTopY_H1
	lda #0
	sta m_playerExplosionScreenTopY_L1

	lda #1
	sta m_playerExplosionStep

	rts


;================================================================================
;================================================================================
PlayerMethodStatic


	jmp PlayerMethodReturn


;================================================================================
CheckCollectable

; check middle left center pixel, to see if there is a collectable
	lda #0
	sta m_bottomPosOffsetX
	lda #4
	sta m_bottomPosOffsetY
	jsr CheckPlayerBottomUpPos

	and #15
	cmp #CT_COLLECTABLE
	beq CC_start_animation

; check if right side pixel is in other char
	lda m_playerLevelLeftX_H1
	and #%11		; "m_playerSizeXMinusOne"
	beq CC_exit

; check the right side char then
	iny
	lda (m_ptrLevelLine),y
	tax
	lda TabCharDefinition,x
	and #15
	cmp #CT_COLLECTABLE
	bne CC_exit

	inc m_middleBottomCharPosX

; erase the collectable with the correct animation
CC_start_animation
	lda m_ptrLevelLine
	clc
	adc m_middleBottomCharPosX
	sta m_pageZeroTempPointer
	lda m_ptrLevelLine+1
	adc #0
	sta m_pageZeroTempPointer+1

	jsr AddCoinAnimation

	dec m_goldCounter
	
CC_exit
	rts


;================================================================================
DoSideMovement

	lda m_stick0
	and #[STICK_MASK_RIGHT | STICK_MASK_LEFT]
	cmp #[STICK_MASK_RIGHT | STICK_MASK_LEFT]
	bne DSM_check_right		; if one or both are pressed, just continue

; no side movement input, reset speed (or deaccelerate..)
; 	lda #0
; 	sta m_playerSideSpeed_H1
; 	sta m_playerSideSpeed_L1


;----------------------------------------
DSM_check_deaccel_right
	lda m_lastPlayerSideDirection
	cmp #PSD_RIGHT
	bne DSM_check_deaccel_left

	jsr SubstractSideDeaccelToSpeed

	jsr AddSideSpeedToPosition

	jmp DSM_exit


;----------------------------------------
DSM_check_deaccel_left
	cmp #PSD_LEFT
	beq DSM_cdl1
	jmp DSM_exit

DSM_cdl1
	jsr SubstractSideDeaccelToSpeed

	jsr SubstractSideSpeedToPosition

	jmp DSM_exit


;----------------------------------------
DSM_check_right
	and #STICK_MASK_RIGHT	; check right
	bne DSM_check_left

	lda m_lastPlayerSideDirection
	cmp #PSD_LEFT
	bne DSM_move_to_right

	lda #0
	sta m_playerSideSpeed_H1
	sta m_playerSideSpeed_L1

DSM_move_to_right
	lda #PSD_RIGHT
	sta m_lastPlayerSideDirection

	jsr AddSideAccelToSpeed

	jsr AddSideSpeedToPosition

	jmp DSM_exit


;----------------------------------------
DSM_check_left
	lda m_stick0
	and #STICK_MASK_LEFT	; check left
	bne DSM_exit

	lda m_lastPlayerSideDirection
	cmp #PSD_RIGHT
	bne DSM_move_to_left

	lda #0
	sta m_playerSideSpeed_H1
	sta m_playerSideSpeed_L1

DSM_move_to_left
	lda #PSD_LEFT
	sta m_lastPlayerSideDirection

	jsr AddSideAccelToSpeed

	jsr SubstractSideSpeedToPosition


;----------------------------------------
DSM_exit
	rts


;================================================================================
DoSideControl

	lda m_stick0
	and #[STICK_MASK_RIGHT | STICK_MASK_LEFT]
	cmp #[STICK_MASK_RIGHT | STICK_MASK_LEFT]
	beq DSC_check_right		; if neither is pressed, just continue

;----------------------------------------
DSC_side_control_right
	and #STICK_MASK_RIGHT
	bne DSC_side_control_left

	lda m_lastPlayerSideDirection
	cmp #PSD_RIGHT
	bne DSC_scr1

	jsr AddSideAccelToSpeed

	jmp DSC_check_right

DSC_scr1
	cmp #PSD_LEFT
	bne DSC_scr2

	jsr SubstractSideDeaccelToSpeed

	jmp DSC_check_right

DSC_scr2
	lda #PSD_RIGHT
	sta m_lastPlayerSideDirection

	jsr AddSideAccelToSpeed

	jmp DSC_check_right


;----------------------------------------
DSC_side_control_left
	lda m_lastPlayerSideDirection
	cmp #PSD_LEFT
	bne DSC_scl1

	jsr AddSideAccelToSpeed

	jmp DSC_check_right

DSC_scl1
	cmp #PSD_RIGHT
	bne DSC_scl2

	jsr SubstractSideDeaccelToSpeed

	jmp DSC_check_right

DSC_scl2
	lda #PSD_LEFT
	sta m_lastPlayerSideDirection

	jsr AddSideAccelToSpeed


;----------------------------------------
DSC_check_right
	lda m_lastPlayerSideDirection
	cmp #PSD_RIGHT
	bne DSC_check_left

	jsr AddSideSpeedToPosition
	jmp DSC_exit


DSC_check_left
	cmp #PSD_LEFT
	bne DSC_exit

	jsr SubstractSideSpeedToPosition


;----------------------------------------
DSC_exit
	rts


;================================================================================

	icl "state_in_platform.asm"

;================================================================================

	icl "state_jumping.asm"

;================================================================================

	icl "state_falling.asm"

;================================================================================

	icl "state_climbing.asm"

;================================================================================

	icl "state_in_water.asm"

;================================================================================
PlayerMethodGravityTest


	jmp PlayerMethodReturn


;================================================================================
PlayerMethodLose


	jmp PlayerMethodReturn

